---
title: Console API
slug: Web/API/Console_API
tags:
  - API
  - Debugging
  - Overview
  - console
  - dump
  - log
  - output
  - test
---
<div>{{DefaultAPISidebar("Console API")}}</div>

<p><span class="seoSummary">The Console API provides functionality to allow developers to perform debugging tasks, such as logging messages or the values of variables at set points in your code, or timing how long an operation takes to complete.</span></p>

<p>{{AvailableInWorkers}}</p>

<h2 id="Concepts_and_usage">Concepts and usage</h2>

<p>The Console API started as a largely proprietary API, with different browsers implementing it, albeit it in inconsistent ways. <a href="https://console.spec.whatwg.org/">The Console API spec</a> was created to define consistent behavior, and all modern browsers eventually settled on implementing this behavior — although some implementations still have their own additional proprietary functions. Find out about these at:</p>

<ul>
 <li><a href="https://developers.google.com/chrome-developer-tools/docs/console-api">Google Chrome DevTools implementation</a></li>
 <li><a href="https://developer.apple.com/library/safari/documentation/AppleApplications/Conceptual/Safari_Developer_Guide/Console/Console.html">Safari DevTools implementation</a></li>
</ul>

<p>Usage is very simple — the {{domxref("console")}} object — available via {{domxref("window.console")}}, or {{domxref("WorkerGlobalScope.console")}} in workers; accessible using just <code>console</code> — contains many methods that you can call to perform rudimentary debugging tasks, generally focused around logging various values to the browser's <a href="/en-US/docs/Tools/Web_Console">Web Console</a>.</p>

<p>By far the most commonly-used method is {{domxref("console.log")}}, which is used to log the current value contained inside a specific variable.</p>

<h2 id="Interfaces">Interfaces</h2>

<dl>
 <dt>{{domxref("console")}}</dt>
 <dd>Provides rudimentary debugging functionality, including logging, stack traces, timers, and counters.</dd>
</dl>

<h2 id="Examples">Examples</h2>

<pre class="brush: js notranslate">let myString = 'Hello world';

// Output "Hello world" to the console
console.log(myString)</pre>

<p>See the <a href="/en-US/docs/Web/API/Console#Usage">Console reference page</a> for more examples.</p>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{SpecName('Console API')}}</td>
   <td>{{Spec2('Console API')}}</td>
   <td>Initial definition.</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.Console")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="/en-US/docs/Tools" title="Tools">Tools</a></li>
 <li><a href="/en-US/docs/Tools/Web_Console" title="Web Console">Web Console</a> — how the Web Console in Firefox handles console API calls</li>
 <li><a href="/en-US/docs/Tools/Remote_Debugging">Remote debugging</a> — how to see console output when the debugging target is a mobile device</li>
</ul>
